#!/usr/bin/perl -w
# +======================================================================+
# || cipux_setup_ldap_configuration                                     ||
# ||                                                                    ||
# || This script inserts the default CipUX configuration into the       ||
# || LDAP.                                                              ||
# ||                                                                    ||
# ||                                                                    ||
# || (c) 2005 by Christian Kuelker                                      ||
# ||                                                                    ||
# || License: GPLv2 (GPL version 2 or later)                            ||
# ||                                                                    ||
# +======================================================================+

my $password = `grep Ldap_Password /etc/cipux/cipux.conf`;
chomp($password);
$password =~ s/ //g;
$password =~ s/Ldap_Password=//g;

&usage if not defined($password);
&usage if $password eq "secret";

print "="x76 . "\n";
print "add ou=CipUX,dc=skole,dc=skolelinux,dc=no\n";
print "="x76;
print "\n";

if($password eq ""){
  print "ERROR: please define a password in this script!\n";
  exit(1);
}

if( -e "/etc/cipux/ldap/cipux_ldap_configuration.ldif"){

  @ldif = `cat /etc/cipux/ldap/cipux_ldap_configuration.ldif`;

  # add the objects
  my $cmd = "| /usr/bin/ldapadd  -x -p 389 -h localhost -w '$password' -ZZ  -D 'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no' ";
  open(CMD,$cmd) or die "can't execute command: [$cmd]";
  foreach my $line (@ldif){
    print CMD $line;
  }
  close(CMD);
}else{
  print "ERROR: the file /etc/cipux/ldap/cipux_ldap_configuration.ldif is no there!\n";
  print "       Please install it.\n";
  exit(1);
}

exit(0);

sub usage{

  print "="x76 . "\n";
  print "ERROR: The Ldap_Password of /etc/cipux/cipux.conf can't be extracted!\n";
  print "Please edit /etc/cipux/cipux.conf and the line Ldap_Password=secret\n";
  print "Change 'secret' to your LDAP/root password!\n";
  print "="x76 . "\n";

}
