#!/usr/bin/perl -w
# +======================================================================+
# || cipux_setup_ldap_machines                                          ||
# ||                                                                    ||
# || This script moves the LDAP ou=Machines,ou=People, ... one level    ||
# || up to ou=Machines.                                                 ||
# ||                                                                    ||
# ||                                                                    ||
# || (c) 2005 by Christian Kuelker                                      ||
# ||                                                                    ||
# || License: GPLv2 (GPL version 2 or later)                            ||
# ||                                                                    ||
# +======================================================================+


my $password = `grep Ldap_Password /etc/cipux/cipux.conf`;
chomp($password);
$password =~ s/ //g;
$password =~ s/Ldap_Password=//g;

&usage if not defined($password);
&usage if $password eq "secret";


print "="x76;
print "\nmigrates Skolelinux (sarge)  Machines  from\n";
print "ou=Machines,ou=People,dc=skole,dc=skolelinux,dc=no\n";
print "                     to\n";
print "ou=Machines,dc=skole,dc=skolelinux,dc=no\n";
print "="x76;
print "\n";

if($password eq ""){
  print "ERROR: please define a password in this script!\n";
  exit(1);
}


my @ldif = `/usr/bin/ldapsearch -x -p 389 -h localhost -w '$password' -ZZ  -D 'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no' -b 'ou=Machines,ou=People,dc=skole,dc=skolelinux,dc=no' -LLL`;

# calc the dn to be deleted
foreach my $line (@ldif){
  print $line;
  if($line =~ m/^dn:(.+)/){
    push(@del,$1);
  }
}

# do it in reverse order
@rdel = reverse @del;
foreach my $obj (@rdel){
  print "DELETE: [$obj]\n";
  my $cmd ="/usr/bin/ldapdelete -x -p 389 -h localhost -w '$password' -ZZ  -D 'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no' $obj";
 print "CMD [$cmd]\n";
 `$cmd`;
}

# so calc the new dn now
foreach my $line (@ldif){
  print $line;
  $line =~s/ou=People,//g;
  print $line;
}

# add the objects
my $cmd = "| /usr/bin/ldapadd  -x -p 389 -h localhost -w '$password' -ZZ  -D 'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no' ";
open(CMD,$cmd) or die "can't execute command: [$cmd]";
foreach my $line (@ldif){
  print CMD $line;
}
close(CMD);


exit(0);



sub usage{

  print "="x76 . "\n";
  print "ERROR: The Ldap_Password of /etc/cipux/cipux.conf can't be extracted!\n";
  print "Please edit /etc/cipux/cipux.conf and the line Ldap_Password=secret\n";
  print "Change 'secret' to your LDAP/root password!\n";
  print "="x76 . "\n";

}
