#!/bin/bash
# +=======================================================================+
# || delete_all_user_group_objects_without_meta_objects.sh               ||
# || (1) deletes all users and courses (groups)                          ||
# || (2) repair meta groups: member, memberUid                           ||
# ||                                                                     ||
# || (c) Copyright 2005 by Christian Kuelker                             ||
# || License: GPLv2 or later                                             ||
# || 2005-03-26                                                          ||
# +=======================================================================+

# 2005-08-11 ckuelker: add new roles and correct script names

FLAG="u c"
META="examinee guest student teacher tutor assistent"

$DIR/list.pl -U >/tmp/u.list
$DIR/list.pl -C >/tmp/c.list

for f in $FLAG; do
  for u in `cat /tmp/$f.list`;do
    case $u in
      "root"      ) echo "do nothing with $f $u";;
      "guest"     ) echo "do nothing with $f $u";;
      "examinee"  ) echo "do nothing with $f $u";;
      "teacher"   ) echo "do nothing with $f $u";;
      "student"   ) echo "do nothing with $f $u";;
      "tutor"     ) echo "do nothing with $f $u";;
      "assistent" ) echo "do nothing with $f $u";;
      "Machine"   ) echo "do nothing with $f $u";;
      "admin"     ) echo "do nothing with $f $u";;
                 *) echo "delete $f $u " && cipux_del -$f $u ;;
    esac
  done
done

for m in $META;do
  cipux_set_value -c $m -e memberUid -v $m
  # $DIR/set_value.pl -c $m -e member -v "uid=$m,ou=People,dc=skole,dc=skolelinux,dc=no"
done
