#!/bin/sh

#                     1  /skole/tjener/home0 teacher wbolte
# refine_homedir.sh MODE HOMEDIRPATH        SKELUSER USER
#              (MODE=1 restore, MODE=2 reset)

# based on:
# homedir_reset
#
# Copyright (c) 2000-2100 Martin Herweg
# please send bugfixes or comments to m.herweg@gmx.de
# licence: GPL
#
# 9.6.2003 OOo 1.0.1 -> 1.0.2
#          moz: appreg
#
# 27.2.2005 falsche parameter werden abgefangen, firefox zeilen
# 11.3.  05 "exam" Benutzer
# 12.3.     staroffice7
# 29.3.     script.xlc , dialog.xlc fr OOo 1.1.2
# MH ---------------------------------------------------------

TEILPFAD=""

UBACK=$USER

case "$1" in
  restore)
 RSO=""
 ;;
  reset)
 RSO="--delete --force"
 ;;
 *)
     echo "Usage: " #         1      2            3       4
     echo "refine_homedir.sh MODE HOMEDIRPATH  SKELUSER USER"
     echo "              (MODE=restore oder reset)"

     exit 1
esac


#  if [ $# -lt 4 ] ; then usage ; break ; fi

HOMEWURZEL=$2
SKELPATH=$HOMEWURZEL
SKELUSER=$3
USER=$4
#GRUPPE=$USER   # skolelinux private groups
# nicht bei exam-Users ;-(
GRUPPE=`id -g $USER`

SKELDIR="$SKELPATH/$SKELUSER/"
TEILPFAD=""

if [ ! -d $HOMEWURZEL ]; then
  echo "ERROR: Verzeichnis $HOMEWURZEL exisitiert nicht"
  exit 1
fi


if [ -z $SKELUSER  ] ; then
  echo "ERROR: Benutzer "Quelle" (3.parameter) fehlt "
  exit 1
fi

id -un $SKELUSER >/dev/null
if [ $? -ne 0 ]  ; then
  echo "ERROR: Benutzer $SKELUSER (Quelle) existiert nicht "
  exit 1
fi

if [ -z $USER  ]  ; then
  echo "ERROR: Benutzer "Ziel" (4.parameter) fehlt "
  exit 1
fi

id -un $USER >/dev/null
if [ $? -ne 0 ]  ; then
  echo "ERROR: Benutzer $USER (Ziel) existiert nicht "
  exit 1
fi

UBACK=$USER

echo "refine_homedir.sh: Quelle:$SKELUSER Ziel:$USER Mode:$1"

# ERST von skel nach  /home/$USER syncopieren
rsync -alW $RSO  $SKELDIR  $HOMEWURZEL/$USER/

# DANN IM homeverzeichnis des users, die Dateien anpassen:
cd $HOMEWURZEL/$USER

#########################################################################
#  Mozilla u.a.
#
# erstmal auskommentiert, moeglichst alles mit globalen Einstellungen loesen

# firefox-teil vom HBBK :
#SLT=5psjh8v0.default
#sed -e s/referenz/$USER/ $SKELDIR/.mozilla/firefox/$SLT/prefs.js > .mozilla/firefox/$SLT/prefs.js
#sed -e s/referenz/$USER/ $SKELDIR/.mozilla/firefox/$SLT/XUL.mfasl > .mozilla/firefox/$SLT/XUL.mfasl
#sed -e s/referenz/$USER/ $SKELDIR/.mozilla/firefox/$SLT/chrome/chrome.rdf > .mozilla/firefox/$SLT/chrome/chrome.rdf
#sed -e s/referenz/$USER/ $SKELDIR/.mozilla/firefox/$SLT/secmod.db > .mozilla/firefox/$SLT/secmod.db

#mozilla
#/usr/local/sbin/moz-appreg.pl $SKELUSER $USER
#SLT=7n2qeqsk.slt
#sed -e s/$SKELUSER/$USER/ $SKELDIR/.mozilla/default/$SLT/prefs.js > .mozilla/default/$SLT/prefs.js
#sed -e s/$SKELUSER/$USER/ $SKELDIR/.mozilla/default/$SLT/XUL.mfasl > .mozilla/default/$SLT/XUL.mfasl


# StarOffice & Openoffice.org  - build ~/.sversionrc
#
sed s/$SKELUSER/$USER/ $SKELDIR/.sversionrc > .sversionrc

##############################################################################
# OpenOffice 1.1
#

TEILPFAD=".openoffice/1.1.2"
 sed s/$SKELUSER/$USER/ $SKELDIR/$TEILPFAD/instdb.ins > $TEILPFAD/instdb.ins

TEILPFAD=".openoffice/1.1.2/user/registry/data/org/openoffice"
sed s/$SKELUSER/$USER/ $SKELDIR/$TEILPFAD/Setup.xcu >  $TEILPFAD/Setup.xcu

TEILPFAD=".openoffice/1.1.2/user/basic"
sed s/$SKELUSER/$USER/ $SKELDIR/$TEILPFAD/script.xlc >  $TEILPFAD/script.xlc
sed s/$SKELUSER/$USER/ $SKELDIR/$TEILPFAD/dialog.xlc >  $TEILPFAD/dialog.xlc

##############################################################################
# Staroffice 7

TEILPFAD=".staroffice7"
sed s/$SKELUSER/$USER/ $SKELDIR/$TEILPFAD/instdb.ins > $TEILPFAD/instdb.ins
TEILPFAD=".staroffice7/user/registry/data/org/openoffice"
sed s/$SKELUSER/$USER/ $SKELDIR/$TEILPFAD/Setup.xcu >  $TEILPFAD/Setup.xcu


#############################################################################
# xchat
#
sed s/$SKELUSER/$USER/ .xchat2/xchat.conf > .xchat2/xchat.conf.tmp
mv  .xchat2/xchat.conf.tmp .xchat2/xchat.conf

 ############################################################################
 # KDE 3.x
 #
 #

 rm  .kde/socket-*
 rm  .kde/tmp-*

TEILPFAD=".kde/share/config"
 sed s/$SKELUSER/$USER/ $SKELDIR/$TEILPFAD/ksmserverrc >  $TEILPFAD/ksmserverrc

############################################################################
############################################################################

chown -R $USER:$GRUPPE $HOMEWURZEL/$USER
touch $HOMEWURZEL/$USER


echo "...fertig."


USER=$UBACK

# EOF ---------------------------------


