#!/usr/bin/perl -w
# +=========================================================================+
# || cipux_set_quota
# || (c) Copyright 2005 by Christian Kuelker
# || License: GPL Version 2 or later
# +=========================================================================+

=pod

=head1 NAME

cipux_set_quota - Version <[CIBOT::VERSION]>  2005-03-30 CipUX

=head1 SYNOPSIS

  cipux_set_quota

=head1 ABSTRACT

This script sets quota.

=head1 REQUIREMENTS

  cibot3.pm

=cut

package cipux_set_quota;

use CipUX::CiBot;

my $filesystem = shift;
my $uidNumber = shift;
my $size = shift;
my $type = shift;;

&usage if not defined($filesystem);
&usage if not defined($uidNumber);
&usage if not defined($size);
&usage if not defined($type);

&log('cipux_set_quota',"="x76);
&log('cipux_set_quota',"cipux_set_quota($filesystem, $uidNumber, $size, $type)");

&cibot_cipux_set_quota($filesystem, $uidNumber, $size, $type);


exit(0);

=pod

=head1 FUNCTIONS

=cut

# .........................................................................
# :                               usage                                   :
# .........................................................................

=pod

=head2 usage

Prints a usage message.

=cut

sub usage{

  print "USAGE:\n";
  print "      cipux_set_quota filesystem uidNumber size type\n\n";
  print "      uidNumber or gidNumber\n";
  print "      size: in blocks\n";
  print "      type:  1 = group 0 = user\n\n";
  print "Example:\n";
  print "      cipux_set_quota '/home' 10024 100000 1\n\n";
  exit(1);
}
